SystemOrganization addCategory: #'Glamour-Morphic-Pager'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Announcement'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Brick'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Exception'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Glamour'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Model'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Morphic'!
SystemOrganization addCategory: 'Glamour-Morphic-Pager-Theme'!

!UITheme methodsFor: '*Glamour-Morphic-Pager' stamp: 'AndreiChis 4/24/2014 13:42'!
pagerWidgetThemer
	^ GLMPagerWidgetThemer new! !

GLMMorphicFinderRenderer subclass: #GLMMorphicPagerRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Glamour'!

!GLMMorphicPagerRenderer commentStamp: 'AndreiChis 6/28/2014 21:19' prior: 0!
A GLMMorphicPagerRenderer is xxxxxxxxx.
!

!GLMMorphicPagerRenderer methodsFor: 'callbacks' stamp: 'AliakseiSyrel 2/4/2015 15:17'!
actOnPaneAdded: ann
	container brickRoot pushPane: (self renderObject: ann pane).! !

!GLMMorphicPagerRenderer methodsFor: 'callbacks' stamp: 'AliakseiSyrel 2/4/2015 15:17'!
actOnPaneRemoved: ann
	container brickRoot popPane! !

!GLMMorphicPagerRenderer methodsFor: 'callbacks' stamp: 'AliakseiSyrel 2/4/2015 15:17'!
actOnPaneReplaced: ann
	container brickRoot popAndReplacePane: (self renderObject: ann newPane)! !

!GLMMorphicPagerRenderer methodsFor: 'accessing' stamp: 'AndreiChis 6/28/2014 21:18'!
defaultScrollButtonIconRenderBlock

	^ [ :object | {Form new. Form new} ]! !

!GLMMorphicPagerRenderer methodsFor: 'rendering' stamp: 'AndreiChis 1/10/2016 12:31'!
render: aBrowser
	|pagerModel|
	pagerModel := GLMPagerModel new
		isDependenciesShown: false;
		defaultNumberOfVisiblePages: aBrowser fixedSizePanes;
		minimumPageNumberForScrollbar: aBrowser minimumPageNumberForScrollbar.
	
	aBrowser scrollButtonIconRenderBlock ifNotNil: [
		"result value of the block is raw icon of the Form class"
		pagerModel scrollButtonIconRenderBlock: [ :index | aBrowser scrollButtonIconRenderBlock cull: ((aBrowser panes at: index) port: #entity) value ]
	].
	
	container := (GLMPagerBrick new
		pagerModel: pagerModel;
		yourself) asBrickedMorph.

	"container maxPanes: aBrowser fixedSizePanes."
	self registerAnnouncementsFor: aBrowser.  
	aBrowser panes
		do: [ :each | container brickRoot pushPane: (self renderObject: each) ].
	^ container! !

GLMFinder subclass: #GLMPager
	instanceVariableNames: 'scrollButtonIconRenderBlock minimumPageNumberForScrollbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Glamour'!

!GLMPager class methodsFor: 'accessing' stamp: 'SergeStinckwich 1/24/2016 18:44'!
extensionsPragma
	^ #gtInspectorPresentationOrder:! !

!GLMPager methodsFor: 'accessing' stamp: 'AndreiChis 1/10/2016 12:30'!
minimumPageNumberForScrollbar

	^ minimumPageNumberForScrollbar! !

!GLMPager methodsFor: 'accessing' stamp: 'AndreiChis 1/10/2016 12:30'!
minimumPageNumberForScrollbar: aNumber

	minimumPageNumberForScrollbar := aNumber! !

!GLMPager methodsFor: 'rendering' stamp: 'AliakseiSyrel 6/28/2014 22:05'!
renderGlamorouslyOn: aRenderer

	^ aRenderer renderPager: self! !

!GLMPager methodsFor: 'accessing' stamp: 'AndreiChis 6/28/2014 21:16'!
scrollButtonIconRenderBlock

	^ scrollButtonIconRenderBlock! !

!GLMPager methodsFor: 'accessing' stamp: 'AndreiChis 6/28/2014 21:16'!
scrollButtonIconRenderBlock: aBlock

	scrollButtonIconRenderBlock := aBlock! !

!GLMPager methodsFor: 'testing' stamp: 'AndreiChis 12/10/2014 17:21'!
shouldDisplayPresentationCreateBy: aCollection 
	^ true! !

ImageMorph subclass: #GLMPagerPanePreviewMorph
	instanceVariableNames: 'thumbnail position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Morphic'!

GLMPagerPanePreviewMorph class
	instanceVariableNames: 'uniqueInstance'!

!GLMPagerPanePreviewMorph commentStamp: 'AndreiChis 5/27/2014 19:59' prior: 0!
I am a morph showing a preview image of another morph.  I should be used like a singleton: my class provides an unique instance of me. That instance can be hiden, shown or updated.!

GLMPagerPanePreviewMorph class
	instanceVariableNames: 'uniqueInstance'!

!GLMPagerPanePreviewMorph class methodsFor: 'cleanup' stamp: 'AndreiChis 3/3/2015 13:59'!
cleanUp
	super cleanUp.
	uniqueInstance := nil! !

!GLMPagerPanePreviewMorph class methodsFor: 'actions' stamp: 'AndreiChis 5/27/2014 19:32'!
remove

	self uniqueInstance delete.	
	uniqueInstance := nil.! !

!GLMPagerPanePreviewMorph class methodsFor: 'accessing' stamp: 'AndreiChis 5/27/2014 19:31'!
uniqueInstance
	^ uniqueInstance ifNil: [ uniqueInstance := GLMPagerPanePreviewMorph new ].! !

!GLMPagerPanePreviewMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 5/26/2014 14:17'!
align: aPoint
	
	position := aPoint.! !

!GLMPagerPanePreviewMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 5/26/2014 14:37'!
defaultBorderWidth
	^ 5! !

!GLMPagerPanePreviewMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 5/26/2014 15:16'!
defaultBottomMargin
	^ 11! !

!GLMPagerPanePreviewMorph methodsFor: 'actions' stamp: 'AndreiChis 5/27/2014 19:38'!
hideFromWorld
	"Remove the morph from the world"
	self delete! !

!GLMPagerPanePreviewMorph methodsFor: 'initialization' stamp: 'AndreiChis 5/27/2014 19:30'!
initialize
	super initialize.

	self color: Color transparent.
	
	self theme pagerWidgetThemer previewPaneStyleFor: self.
	self borderWidth: self defaultBorderWidth.! !

!GLMPagerPanePreviewMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 5/26/2014 14:18'!
maxExtent
	^ 300@300.! !

!GLMPagerPanePreviewMorph methodsFor: 'actions' stamp: 'AndreiChis 5/27/2014 19:42'!
showAt: aPoint

	self 
		openInWorld;
		align: aPoint.! !

!GLMPagerPanePreviewMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 2/9/2015 14:39'!
updateFor: aMorph

	thumbnail := aMorph taskThumbnailOfSize: self maxExtent.
	self image: thumbnail form.
	
	self position: position - ((thumbnail width / 2)@(thumbnail height + self defaultBottomMargin + self defaultBorderWidth)).! !

!GLMMorphicRenderer methodsFor: '*Glamour-Morphic-Pager' stamp: 'TudorGirba 6/14/2014 12:10'!
renderPager: aBrowser 
	^ aBrowser hasFixedSizePanes 
		ifTrue: [GLMMorphicPagerRenderer render: aBrowser from: self]
		ifFalse: []! !

GLMInteractableBrick subclass: #GLMPagerScrollButtonBrick
	instanceVariableNames: 'checkedIcon checkedFocusedIcon focused index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Brick'!

!GLMPagerScrollButtonBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/4/2015 14:47'!
checkedFocusedIcon
	^ checkedFocusedIcon! !

!GLMPagerScrollButtonBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/4/2015 14:47'!
checkedFocusedIcon: aForm
	checkedFocusedIcon := aForm.! !

!GLMPagerScrollButtonBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/4/2015 14:47'!
checkedIcon
	^ checkedIcon! !

!GLMPagerScrollButtonBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/4/2015 14:47'!
checkedIcon: aForm
	checkedIcon := aForm.! !

!GLMPagerScrollButtonBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/9/2015 14:17'!
click: anEvent
	super click: anEvent.
	
	self announcer announce: (GLMPagerButtonClicked new buttonModel: self)
	! !

!GLMPagerScrollButtonBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/4/2015 14:59'!
deselect
	super deselect.
	
	self announcer announce: (GLMPagerButtonDeselected new buttonModel: self)
	! !

!GLMPagerScrollButtonBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/4/2015 14:49'!
index
	^ index! !

!GLMPagerScrollButtonBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/4/2015 14:49'!
index: anObject
	index := anObject! !

!GLMPagerScrollButtonBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/4/2015 14:47'!
initialize
	super initialize.

	focused := false.! !

!GLMPagerScrollButtonBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/4/2015 14:47'!
isFocused
	^ focused! !

!GLMPagerScrollButtonBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/4/2015 14:51'!
select
	super select.
	
	self announcer announce: (GLMPagerButtonSelected new buttonModel: self)
	! !

!GLMPagerScrollButtonBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/4/2015 14:48'!
setFocused

	focused ifFalse: [
		self checkedImage: checkedFocusedIcon.
		self check.
		focused := true ]! !

!GLMPagerScrollButtonBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/4/2015 14:48'!
setNotFocused

	focused ifTrue: [
		self checkedImage: checkedIcon.
		self uncheck.
		focused := false ]! !

GLMInteractableBrick subclass: #GLMPagerScrollSlidingBrick
	instanceVariableNames: 'startDragX isResizing startResizingWidth resizingZoneWidth isRightResizing isLeftResizing pagerModel leftPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Brick'!

!GLMPagerScrollSlidingBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/9/2015 11:57'!
computeScrollValue: aNumber
	|newValue delta|
	
	delta := self owner width - self width.
	newValue := (aNumber max: 0) min: delta.
		
	^ ((delta = 0)
		ifTrue: [ 0 ]
		ifFalse: [ newValue / delta ])! !

!GLMPagerScrollSlidingBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/9/2015 11:42'!
computeWidth

	^ self pagerModel
		ifNil: [ 0 ]
		ifNotNil: [ :m | m circleButtonSize * m actualNumberOfVisiblePages ]! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-draging' stamp: 'AliakseiSyrel 2/9/2015 12:52'!
dragResizingLeft: anEvent
	| left right |
	
	right := self brickBounds right.
	left := anEvent position x - self owner globalBounds left - startDragX.
	left := (left max: 0) min: (right - self pagerModel circleButtonSize).
	
	self setPosition: left@right
	! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-draging' stamp: 'AliakseiSyrel 2/9/2015 12:52'!
dragResizingRight: anEvent
	| left right |

	left := self brickBounds left.
	right := anEvent position x - self owner globalBounds left - (startDragX - self computeWidth).
	right := (right max: (left + self pagerModel circleButtonSize)) min: self owner width.
	
	self setPosition: left@right
	! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-draging' stamp: 'AliakseiSyrel 2/8/2015 19:20'!
dragSliding: evt
	| newLeft value|
	
	newLeft := (evt position x - self owner globalBounds left - startDragX).
	value := self computeScrollValue: newLeft.
	
	self scrollTo: value.
	self synchronizeScrollTo: value.! !

!GLMPagerScrollSlidingBrick methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 2/9/2015 11:50'!
handleMouseOver: anEvent
	super handleMouseOver: anEvent.
		
	isResizing | (self isLeftResizingZone: anEvent) | (self isRightResizingZone: anEvent)
		ifTrue: [ self setCursorToResizing: anEvent ]
		ifFalse: [ self setCursorToNormal: anEvent ].! !

!GLMPagerScrollSlidingBrick methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 2/4/2015 15:12'!
handlesMouseOverDragging: evt
	^ true! !

!GLMPagerScrollSlidingBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/9/2015 11:38'!
initialize
	super initialize.
		
	resizingZoneWidth := 7.
	isRightResizing := false.
	isLeftResizing := false.
	isResizing := false.
		
	self
		normalColor: (Color veryLightGray alpha: 0.4);
		selectedColor: (Color veryLightGray alpha: 0.55);
		enable! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-testing' stamp: 'AliakseiSyrel 2/9/2015 11:51'!
isLeftResizingZone: evt
	
	^ (self globalBounds withWidth: resizingZoneWidth) containsPoint: evt position
	
	! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-testing' stamp: 'AliakseiSyrel 2/9/2015 11:50'!
isRightResizingZone: evt
	|resizingRectangle top left globalBounds|
	globalBounds := self globalBounds.
	
	top := globalBounds top.
	left := globalBounds right - resizingZoneWidth.
	
	resizingRectangle := left@top corner: globalBounds corner.
	
	^ resizingRectangle containsPoint: evt position.
	
	! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-accessing' stamp: 'AliakseiSyrel 2/14/2015 12:39'!
leftPosition

	^ leftPosition ifNil: [ leftPosition := 0 ]! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-accessing' stamp: 'AliakseiSyrel 2/14/2015 12:39'!
leftPosition: anInteger

	leftPosition := anInteger! !

!GLMPagerScrollSlidingBrick methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 2/9/2015 11:50'!
mouseDown: evt

	startDragX := (evt position x - self globalBounds left).
	startResizingWidth := self width.
	
	isRightResizing := self isRightResizingZone: evt.
	
	"only one type of resizing is possible"
	isRightResizing
		ifFalse: [ isLeftResizing := self isLeftResizingZone: evt ]
		ifTrue: [ isLeftResizing := false ].

	isResizing := (isLeftResizing or: isRightResizing).
		
	super mouseDown: evt.! !

!GLMPagerScrollSlidingBrick methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 2/4/2015 15:12'!
mouseLeave: evt

	self setCursorToNormal: evt.
	super mouseLeave: evt.! !

!GLMPagerScrollSlidingBrick methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 2/8/2015 19:11'!
mouseMove: evt

	isRightResizing
		ifTrue: [ self dragResizingRight: evt ]
		ifFalse: [
			isLeftResizing
				ifTrue: [ self dragResizingLeft: evt ]
				ifFalse: [ self dragSliding: evt ] ].! !

!GLMPagerScrollSlidingBrick methodsFor: 'event-mouse' stamp: 'AliakseiSyrel 2/9/2015 11:16'!
mouseUp: evt
	super mouseUp: evt.
	
	pagerModel recomputeState: isResizing not.
	
	isResizing ifTrue: [ self setWidthAfterResizing ].
	isResizing := false.
		
	(self globalBounds containsPoint: evt position)
		ifFalse: [ self setCursorToNormal: evt ]
		ifTrue: [ self setCursorToResizing: evt ] ! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-scrolling' stamp: 'AliakseiSyrel 2/14/2015 13:09'!
moveLeft: left "Integer - pixels"
	"moves scrollbar inside parent to the specified left distance in pixels and notifies all listeners about that"
	"Highly optimised to not update layout during moving"
	| right |
	right := left + self width.
	self changedWith: [ :b |
		b translateXTo: left.
		b leftPosition: left ].
	
	pagerModel notifyScrollerBoundsChanged: left@right! !

!GLMPagerScrollSlidingBrick methodsFor: 'brick-layout-events' stamp: 'AliakseiSyrel 2/29/2016 14:07'!
onChildrenLayouted
	super onChildrenLayouted.
	self translateXTo: self leftPosition! !

!GLMPagerScrollSlidingBrick methodsFor: 'brick-layout-events' stamp: 'AliakseiSyrel 2/16/2015 12:01'!
onLayouted
	super onLayouted.
	"'slider onLayouted' logCr."
	self translateXTo: self leftPosition! !

!GLMPagerScrollSlidingBrick methodsFor: 'announcement handling' stamp: 'AliakseiSyrel 2/9/2015 14:28'!
onPositionChanged: announcement
	
	self scrollToPane: pagerModel firstVisiblePageIndex smooth: announcement smooth! !

!GLMPagerScrollSlidingBrick methodsFor: 'announcement handling' stamp: 'AliakseiSyrel 2/9/2015 11:17'!
onResized

	self setWidthAfterResizing! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-accessing' stamp: 'AliakseiSyrel 2/9/2015 11:43'!
pagerModel

	^ pagerModel! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-accessing' stamp: 'PavelKrivanek 4/6/2016 16:17'!
pagerModel: anAdapter
	
	pagerModel := anAdapter.
			
	pagerModel announcer when: GLMNumberOfVisiblePagesChanged send: #onResized to: self.
		
	pagerModel announcer when: GLMPagerScrollPositionChanged send: #onPositionChanged: to: self.
		
	self width: self computeWidth! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-cursor' stamp: 'AliakseiSyrel 2/4/2015 15:12'!
resizeCursor

	^ Cursor resizeForEdge: #left! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-scrolling' stamp: 'AliakseiSyrel 2/9/2015 11:36'!
scrollTo: aFloat "Float - percentage/100"
	"scrolls to a specified float number which must be in interval [0.0, 1.0]"
	self moveLeft: (owner width - self width) * aFloat.! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-scrolling' stamp: 'AliakseiSyrel 2/9/2015 11:35'!
scrollTo: aValue smooth: aBoolean
	"better to ignore smooth parameter,
	because animation is not neccessary"
	self scrollTo: aValue! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-scrolling' stamp: 'AliakseiSyrel 2/4/2015 15:12'!
scrollToPane: anIndex smooth: isSmooth

	self scrollTo: (pagerModel convertIndexToValue: anIndex) smooth: isSmooth.! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-cursor' stamp: 'AliakseiSyrel 2/4/2015 15:12'!
setCursorToNormal: evt
		
	evt hand showTemporaryCursor: nil! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-cursor' stamp: 'AliakseiSyrel 2/4/2015 15:12'!
setCursorToResizing: evt
	
	evt hand showTemporaryCursor: self resizeCursor! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-draging' stamp: 'AliakseiSyrel 2/14/2015 13:01'!
setPosition: aPoint
	"aPoint x - is my bounds left
	aPoint y - is my bounds right"
	"highly optimised to not update layout and do everything very clean"
	self changedWith: [ :b | b
			translateXTo: aPoint x;
			leftPosition: aPoint x;
			doNotLayoutDuring: [
				b width: aPoint y - aPoint x.
				b wrappedBounds markWidthClean ] ].
	
	self pagerModel notifyScrollerBoundsChanged: aPoint! !

!GLMPagerScrollSlidingBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/9/2015 15:00'!
setWidthAfterResizing
	| left right |
	
	left := pagerModel circleButtonSize * (pagerModel firstVisiblePageIndex - 1).
	right := left + self computeWidth.
	
	self setPosition: left@right! !

!GLMPagerScrollSlidingBrick methodsFor: 'slider-scrolling' stamp: 'AliakseiSyrel 2/4/2015 15:12'!
synchronizeScrollTo: aValue

	pagerModel synchronizeScrollTo: aValue.! !

!GLMCompositePresentation methodsFor: '*Glamour-Morphic-Pager' stamp: 'AliakseiSyrel 6/29/2014 00:59'!
pager
	^ self custom: GLMPager new! !

Error subclass: #GLMPagerException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Exception'!

Announcement subclass: #GLMFocusedPageChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

Announcement subclass: #GLMNumberOfVisiblePagesChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

Announcement subclass: #GLMPagePoped
	instanceVariableNames: 'smooth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagePoped methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/14/2014 09:13'!
initialize
	super initialize.
	
	smooth := false.! !

!GLMPagePoped methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/14/2014 09:13'!
smooth
	^ smooth! !

!GLMPagePoped methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/14/2014 09:13'!
smooth: anObject
	smooth := anObject! !

Announcement subclass: #GLMPagePopedAndReplaced
	instanceVariableNames: 'brick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagePopedAndReplaced methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/17/2015 15:07'!
brick
	^ brick! !

!GLMPagePopedAndReplaced methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/17/2015 15:07'!
brick: anObject
	brick := anObject! !

Announcement subclass: #GLMPagePushed
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagePushed methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/5/2014 12:42'!
morph
	^ morph! !

!GLMPagePushed methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/5/2014 12:42'!
morph: aMorph
	morph := aMorph! !

Announcement subclass: #GLMPageSwitched
	instanceVariableNames: 'smooth pageIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPageSwitched methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/23/2014 18:36'!
pageIndex
	^ pageIndex! !

!GLMPageSwitched methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/23/2014 18:36'!
pageIndex: anObject
	pageIndex := anObject! !

!GLMPageSwitched methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/5/2014 17:46'!
smooth
	^ smooth! !

!GLMPageSwitched methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/5/2014 17:46'!
smooth: anObject
	smooth := anObject! !

Announcement subclass: #GLMPagerBoundsChanged
	instanceVariableNames: 'bounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagerBoundsChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 15:29'!
bounds
	^ bounds! !

!GLMPagerBoundsChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 15:29'!
bounds: anObject
	bounds := anObject! !

Announcement subclass: #GLMPagerButtonAnnouncement
	instanceVariableNames: 'buttonModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagerButtonAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 8/19/2014 16:28'!
buttonModel
	^ buttonModel! !

!GLMPagerButtonAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 8/19/2014 16:28'!
buttonModel: anObject
	buttonModel := anObject! !

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonClicked
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonDeselected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

GLMPagerButtonAnnouncement subclass: #GLMPagerButtonSelected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

Announcement subclass: #GLMPagerPreviewUpdate
	instanceVariableNames: 'pageIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagerPreviewUpdate methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/26/2014 13:49'!
pageIndex
	^ pageIndex! !

!GLMPagerPreviewUpdate methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/26/2014 13:49'!
pageIndex: anObject
	pageIndex := anObject! !

Announcement subclass: #GLMPagerScrollPositionChanged
	instanceVariableNames: 'smooth callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagerScrollPositionChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/15/2014 16:13'!
callback
	^ callback! !

!GLMPagerScrollPositionChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/15/2014 16:13'!
callback: anObject
	callback := anObject! !

!GLMPagerScrollPositionChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/27/2014 13:44'!
smooth
	^ smooth! !

!GLMPagerScrollPositionChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/27/2014 13:44'!
smooth: anObject
	smooth := anObject! !

Announcement subclass: #GLMPagerSynchronizeScrollAnnouncement
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

!GLMPagerSynchronizeScrollAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 14:18'!
value
	^ value! !

!GLMPagerSynchronizeScrollAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 14:18'!
value: anObject
	value := anObject! !

Announcement subclass: #GLMSelectedPageChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Announcement'!

GLMBrick subclass: #GLMPagerBarBrick
	instanceVariableNames: 'buttonsBrick pagerModel sliderBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Brick'!

!GLMPagerBarBrick methodsFor: 'bar-accessing' stamp: 'AliakseiSyrel 2/4/2015 11:57'!
buttonsBrick

	^ buttonsBrick! !

!GLMPagerBarBrick methodsFor: 'bar-accessing' stamp: 'AliakseiSyrel 2/4/2015 14:57'!
buttonsBrick: aBrick

	buttonsBrick := aBrick.
	
	self buttonsBrick pagerModel: pagerModel.
	
	self buttonsBrick
		hShrinkWrap;
		vShrinkWrap.
	
	self addBrickBack: self buttonsBrick! !

!GLMPagerBarBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/16/2015 09:43'!
initialize
	super initialize.
	
	self
		useVerticalLinearLayout! !

!GLMPagerBarBrick methodsFor: 'bar-instance creation' stamp: 'AliakseiSyrel 2/4/2015 12:46'!
newButtonsBrick

	^ GLMPagerButtonsPaneBrick new! !

!GLMPagerBarBrick methodsFor: 'bar-instance creation' stamp: 'AliakseiSyrel 2/4/2015 15:14'!
newSliderBrick

	^ GLMPagerScrollSlidingBrick new! !

!GLMPagerBarBrick methodsFor: 'bar-event-handling' stamp: 'AliakseiSyrel 2/4/2015 14:45'!
onPagePoped

	buttonsBrick onPagePoped.
	self recomputeScrollBar.! !

!GLMPagerBarBrick methodsFor: 'bar-event-handling' stamp: 'AliakseiSyrel 2/16/2015 12:17'!
onPagePushed: addedAnnouncement

	self buttonsBrick onPagePushed: addedAnnouncement.
	self recomputeScrollBar! !

!GLMPagerBarBrick methodsFor: 'bar-accessing' stamp: 'AliakseiSyrel 2/4/2015 11:41'!
pagerModel

	^ pagerModel! !

!GLMPagerBarBrick methodsFor: 'bar-accessing' stamp: 'PavelKrivanek 4/6/2016 16:16'!
pagerModel: aModel
	
	pagerModel := aModel.
	
	self pagerModel announcer when: GLMPagePushed send: #onPagePushed: to: self.
	self pagerModel announcer when: GLMPagePoped send: #onPagePoped to: self.
	
	self sliderBrick: self newSliderBrick.
	self buttonsBrick: self newButtonsBrick.! !

!GLMPagerBarBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/9/2015 15:01'!
recomputeScrollBar
	
	self sliderBrick ifNotNil: #setWidthAfterResizing! !

!GLMPagerBarBrick methodsFor: 'bar-accessing' stamp: 'AliakseiSyrel 2/9/2015 15:01'!
sliderBrick

	^ sliderBrick! !

!GLMPagerBarBrick methodsFor: 'bar-accessing' stamp: 'AliakseiSyrel 2/8/2015 20:25'!
sliderBrick: aBrick

	sliderBrick := aBrick.
	
	self sliderBrick
		pagerModel: self pagerModel;
		height: self pagerModel circleButtonSize;
		width: [ self pagerModel circleButtonSize * self pagerModel actualNumberOfVisiblePages ].
		
	self sliderBrick layout
		floating: #left.
		
	self addBrickBack: self sliderBrick! !

GLMBrick subclass: #GLMPagerBrick
	instanceVariableNames: 'firstCombination pagerBar scrollBrick pagerModel showScrollBarWhenNeeded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Brick'!

!GLMPagerBrick class methodsFor: 'examples' stamp: 'AliakseiSyrel 2/4/2015 17:49'!
exampleBasic
	|pager adapter|
	adapter := GLMPagerModel new.
	pager :=	GLMPagerBrick new.
	pager pagerModel: adapter.
	pager pushPane: (GLMLabelBrick new color: Color lightRed; text: 'Hello'; textPosition: #center).
	"pager pushPane: (GLMBrick new color: Color green).
	pager pushPane: (GLMBrick new color: Color yellow).
	pager pushPane: (GLMBrick new color: Color blue).
	pager pushPane: (GLMBrick new color: Color pink)."
	
	pager height: 600.
	pager width: 1024.
	pager asBrickedMorph openInWindow.
	
	pager inspect.! !

!GLMPagerBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/4/2015 11:30'!
initialColorInSystemWindow: aSystemWindow
	"Answer the colour the receiver should be when added to a SystemWindow."
	^ Color transparent! !

!GLMPagerBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/8/2015 17:42'!
initialize
	super initialize.
	
	self useVerticalLinearLayout! !

!GLMPagerBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/4/2015 11:29'!
initializeShortcuts

	self
		bindKeyCombination: Character arrowLeft alt command
		toAction: [ self pagerModel selectToLeft ].
	
	self
		bindKeyCombination: Character arrowRight alt command
		toAction: [ self pagerModel selectToRight ].
	
	self
		bindKeyCombination: Character arrowLeft alt shift command
		toAction: [ self pressedScrollerSizeCombination: #left ].

	self
		bindKeyCombination: Character arrowRight alt shift command
		toAction: [ self pressedScrollerSizeCombination: #right ].! !

!GLMPagerBrick methodsFor: 'pager-instance creation' stamp: 'AliakseiSyrel 2/4/2015 12:47'!
newPagerBar

	^ GLMPagerBarBrick new! !

!GLMPagerBrick methodsFor: 'pager-instance creation' stamp: 'AliakseiSyrel 2/4/2015 12:47'!
newScrollBrick

	^ GLMPagerScrollBrick new! !

!GLMPagerBrick methodsFor: 'pager-event-handling' stamp: 'AliakseiSyrel 2/4/2015 15:19'!
onPagePoped

	self showOrHideScrollBar! !

!GLMPagerBrick methodsFor: 'pager-event-handling' stamp: 'AliakseiSyrel 2/4/2015 15:19'!
onPagePushed

	self showOrHideScrollBar! !

!GLMPagerBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/4/2015 11:19'!
outOfWorld: aWorld

	GLMPagerPanePreviewMorph remove.
	^ super outOfWorld: aWorld.! !

!GLMPagerBrick methodsFor: 'pager-accessing' stamp: 'AliakseiSyrel 2/4/2015 11:21'!
pagerBar

	^ pagerBar! !

!GLMPagerBrick methodsFor: 'pager-accessing' stamp: 'AliakseiSyrel 2/4/2015 13:56'!
pagerBar: aBrick

	pagerBar := aBrick.
	
	self pagerBar
		vShrinkWrap;
		hShrinkWrap.
	self pagerBar layout hAlign: #center.
	
	self pagerBar pagerModel: pagerModel.
	
	self addBrickBack: self pagerBar! !

!GLMPagerBrick methodsFor: 'pager-accessing' stamp: 'AliakseiSyrel 2/4/2015 11:19'!
pagerModel
	^ pagerModel! !

!GLMPagerBrick methodsFor: 'pager-accessing' stamp: 'PavelKrivanek 4/6/2016 16:16'!
pagerModel: aModel

	pagerModel := aModel.
	
	self pagerModel announcer when: GLMPagePushed send: #onPagePushed to: self.
	self pagerModel announcer when: GLMPagePoped send: #onPagePoped to: self.
	
	self initializeShortcuts.
	
	self scrollBrick: self newScrollBrick.
	self pagerBar: self newPagerBar! !

!GLMPagerBrick methodsFor: 'pager-api' stamp: 'AliakseiSyrel 2/4/2015 11:27'!
popAndReplacePane: aMorph
	"replaces last pane with new pane"
	self pagerModel popAndReplacePane: aMorph! !

!GLMPagerBrick methodsFor: 'pager-api' stamp: 'AliakseiSyrel 2/4/2015 11:27'!
popPane
	"pops the last pane with smooth animation"
	self pagerModel popPane: true.! !

!GLMPagerBrick methodsFor: 'pager-actions' stamp: 'AliakseiSyrel 2/4/2015 11:19'!
pressedScrollerSizeCombination: aSymbol

	firstCombination ifNil: [ firstCombination := aSymbol. ^ self].
	
	self scrollerSizeShortcutAction: firstCombination second: aSymbol.
	firstCombination := nil.! !

!GLMPagerBrick methodsFor: 'pager-api' stamp: 'AliakseiSyrel 2/4/2015 11:27'!
pushPane: aMorph
	"pushes a pane to the end with smooth scroll animation"
	self pagerModel pushPane: aMorph smooth: true.
	! !

!GLMPagerBrick methodsFor: 'pager-accessing' stamp: 'AliakseiSyrel 2/4/2015 11:33'!
scrollBrick

	^ scrollBrick! !

!GLMPagerBrick methodsFor: 'pager-accessing' stamp: 'AliakseiSyrel 2/4/2015 13:23'!
scrollBrick: aBrick

	scrollBrick := aBrick.
	self scrollBrick pagerModel: pagerModel.
	
	self scrollBrick
		vSpaceFill;
		hSpaceFill.
	
	self addBrickBack: self scrollBrick! !

!GLMPagerBrick methodsFor: 'pager-actions' stamp: 'MarcusDenker 10/6/2016 12:03'!
scrollerSizeShortcutAction: first second: second
	
	(first = #left) & (second = #left) ifTrue: [ pagerModel enlargeToLeft ].
	(first = #left) & (second = #right) ifTrue: [ pagerModel diminishToRight ].
	(first = #right) & (second = #left) ifTrue: [ pagerModel diminishToLeft ].
	(first = #right) & (second = #right) ifTrue: [ pagerModel enlargeToRight ]! !

!GLMPagerBrick methodsFor: 'pager-actions' stamp: 'AndreiChis 1/10/2016 12:32'!
showOrHideScrollBar
	
	((self pagerModel size > self pagerModel minimumPageNumberForScrollbar) & (self showScrollBarWhenNeeded))
		ifTrue: [ (self hasSubbrick: self pagerBar)
			ifFalse: [ self addBrickBack: self pagerBar ] ]
		ifFalse: [ self removeBrick: self pagerBar ].! !

!GLMPagerBrick methodsFor: 'pager-accessing' stamp: 'AliakseiSyrel 2/4/2015 11:22'!
showScrollBarWhenNeeded
	"retuns true if scrollbar should be visible if number of pages > 1,
	otherwise false"
	^ showScrollBarWhenNeeded ifNil: [ showScrollBarWhenNeeded := true ]! !

!GLMPagerBrick methodsFor: 'pager-accessing' stamp: 'AliakseiSyrel 2/4/2015 11:19'!
showScrollBarWhenNeeded: aBoolean

	showScrollBarWhenNeeded := aBoolean! !

GLMBrick subclass: #GLMPagerButtonsPaneBrick
	instanceVariableNames: 'pagerModel buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Brick'!

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-adding' stamp: 'PavelKrivanek 4/6/2016 16:16'!
addButton: aBrick

	self buttons add: aBrick.
	
	aBrick enable.
	aBrick index: self buttons size.
	aBrick announcer when: GLMPagerButtonClicked send: #onButtonClicked: to: self.
	aBrick announcer when: GLMPagerButtonSelected send: #onButtonSelected: to: self.
	aBrick announcer when: GLMPagerButtonDeselected send: #onButtonDeselected to: self.
	
	self theme pagerWidgetThemer defaultScrollButtonStyleFor: aBrick.
	
	aBrick height: self pagerModel circleButtonSize.
	aBrick width: self pagerModel circleButtonSize.
	
	self addBrickBack: aBrick.
	
	(self buttons size = 1) ifTrue: [ self updateButtonsFocus ].
		
	self updateButtons.! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-calculations' stamp: 'AliakseiSyrel 2/9/2015 11:29'!
buttonCenterByIndex: aNumber
	| width |
	width := self pagerModel circleButtonSize.
	^ ( ( aNumber - 1 ) * ( width ) ) + ( width / 2 ).! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-accessing' stamp: 'AliakseiSyrel 2/4/2015 12:24'!
buttons

	^ buttons ifNil: [ buttons := OrderedCollection new ]! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-accessing' stamp: 'AliakseiSyrel 2/4/2015 12:24'!
buttons: anObject

	buttons := anObject! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-testing' stamp: 'AliakseiSyrel 2/4/2015 12:11'!
isScrollMustBeChecked: anIndex withLeft: leftBound andRight: rightBound
	| buttonCenter |
	
	buttonCenter := self buttonCenterByIndex: anIndex.
	^ (leftBound <= buttonCenter ) & (rightBound > buttonCenter)! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-updating' stamp: 'AliakseiSyrel 2/9/2015 14:25'!
markButtonsInside: aBounds
	|index boundsLeft boundsRight firstFound lastFound |	
	self flag: 'refactor me'.
	
	firstFound := false.
	lastFound := false.
	index := 0.
	
	(pagerModel size = 0) ifTrue: [ ^ self ].
	boundsLeft := aBounds x.
	boundsRight := aBounds y.
	
	self buttons do: [ :indicator |
		index := index + 1.
		(self isScrollMustBeChecked: index withLeft: boundsLeft andRight: boundsRight)
			ifTrue: [
				indicator check.
				firstFound ifFalse: [
					pagerModel virtualFirstVisiblePageIndex: index.
					firstFound := true.
				]
			]
			ifFalse: [
				"uncheck only if not focused"
				indicator isFocused ifFalse: [ indicator uncheck ].
				(firstFound & (lastFound = false)) ifTrue: [
					pagerModel virtualLastVisiblePageIndex: index - 1.
					lastFound := true.
				]
			].
	].
	lastFound ifFalse: [
		pagerModel virtualLastVisiblePageIndex: index.
		lastFound := true.
	]
	
		
! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-instance-creation' stamp: 'AliakseiSyrel 2/4/2015 14:49'!
newButton

	^ GLMPagerScrollButtonBrick new! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-event-handling' stamp: 'AliakseiSyrel 2/9/2015 14:20'!
onButtonClicked: ann

	self pagerModel switchPaneTo: ann buttonModel index! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-event-handling' stamp: 'AliakseiSyrel 2/9/2015 14:19'!
onButtonDeselected

	GLMPagerPanePreviewMorph uniqueInstance hideFromWorld! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-event-handling' stamp: 'AliakseiSyrel 2/9/2015 14:21'!
onButtonSelected: ann

	"notify adapter that we need to update pane preview"
	GLMPagerPanePreviewMorph uniqueInstance showAt: (self buttons at: ann buttonModel index) globalBounds topCenter.
	self pagerModel updatePreview: ann buttonModel index! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-event-handling' stamp: 'AliakseiSyrel 2/9/2015 14:21'!
onFocusedPageChanged

	self
		updateButtonsFocus;
		updateButtons
! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-event-handling' stamp: 'AliakseiSyrel 2/9/2015 15:02'!
onPagePoped
	|button|
	
	button := self buttons removeLast.
	button announcer unsubscribe: self.
	
	self owner changed.
	self removeBrick: button.
	self updateButtons! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-event-handling' stamp: 'AliakseiSyrel 2/4/2015 12:37'!
onPagePushed: addedAnnouncement
	
	self addButton: self newButton! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-event-handling' stamp: 'AliakseiSyrel 2/4/2015 15:06'!
onPageSwitched

	self updateButtons! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-event-handling' stamp: 'AliakseiSyrel 2/4/2015 12:11'!
onScrollBoundsChanged: boundsChangedAnnouncement

	self markButtonsInside: boundsChangedAnnouncement bounds.
	! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-accessing' stamp: 'AliakseiSyrel 2/4/2015 12:23'!
pagerModel

	^ pagerModel! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-accessing' stamp: 'PavelKrivanek 4/6/2016 16:16'!
pagerModel: aModel
	
	pagerModel := aModel.
		
	self pagerModel announcer when: GLMPageSwitched send: #onPageSwitched to: self.
	self pagerModel announcer when: GLMPagerBoundsChanged send: #onScrollBoundsChanged: to: self.
	self pagerModel announcer when: GLMFocusedPageChanged send: #onFocusedPageChanged to: self.
		
	self updateButtons! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-updating' stamp: 'AliakseiSyrel 2/9/2015 14:24'!
updateButtons
	"first we uncheck all buttons"
	self buttons select: #isFocused thenDo: #uncheck.
	"then check only necessary"
	self pagerModel size > 0 ifTrue: [
		self buttons from: self pagerModel firstVisiblePageIndex to: self pagerModel lastVisiblePageIndex do: #check ]! !

!GLMPagerButtonsPaneBrick methodsFor: 'buttons-updating' stamp: 'AliakseiSyrel 2/9/2015 14:23'!
updateButtonsFocus
	"unfocus all"
	self buttons do: #setNotFocused.
	"because it's possible when nothing has focus"
	self pagerModel focusedPageIndex
		ifNotNil: [ (self buttons at: self pagerModel focusedPageIndex) setFocused ]
	! !

GLMBrick subclass: #GLMPagerScrollBrick
	instanceVariableNames: 'band currentFocus pagerModel maxPanes focus currentScrollDelta animation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Brick'!

!GLMPagerScrollBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/17/2015 13:32'!
animation

	^ animation! !

!GLMPagerScrollBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/4/2014 09:41'!
band

	^ band! !

!GLMPagerScrollBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/14/2015 13:33'!
band: aBrick

	band := aBrick.
	band
		useHorizontalLinearLayout;
		layoutMorphs: true;
		width: [ self band subbricksCount * self width / ((self maxPanes min: self band subbricksCount) max: 1) ];
		vSpaceFill.
	"band actually depends from myself,
	because each pane is proportional to my size"
	band layout widthDependency: self.
	
	self addBrickBack: band.! !

!GLMPagerScrollBrick methodsFor: 'api' stamp: 'AliakseiSyrel 2/17/2015 17:28'!
configurePane: aBrick
	|brick|
	brick := aBrick asBrick.
	brick
		layoutProperties: GLMBrickLayoutProperties new;
		"width of tab is proportional to number of visible panes and my width"
		width: [ self band width / self band subbricksCount ];
		vSpaceFill;
		marginLeft: self paneMargin;
		marginRight: self paneMargin.
		
	brick layout widthDependency: self band.
	^ brick! !

!GLMPagerScrollBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 2/8/2015 13:46'!
convertScrollValue: aFloat
	self pagerModel actualNumberOfVisiblePages = 0 ifTrue: [ ^ 0 ].
	^ (self width - ((self width / self pagerModel actualNumberOfVisiblePages + self paneMargin) * self band subbricksCount)) * aFloat! !

!GLMPagerScrollBrick methodsFor: 'event-handling' stamp: 'AliakseiSyrel 2/8/2015 16:58'!
focusChanged: anEvent
	| pageIndex newFocus |
	
	newFocus := anEvent morph.
	
	currentFocus = newFocus ifFalse: [
		currentFocus := newFocus.
		pageIndex := self pageOf: newFocus.
		(pageIndex > 0) ifTrue: [
			pagerModel focusedMorphChanged: newFocus at: pageIndex ] ]! !

!GLMPagerScrollBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 12/4/2014 12:00'!
glmAnimateValue: aValue duration: anInteger

	self glmAnimateValue: aValue duration: anInteger callback: nil.! !

!GLMPagerScrollBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 2/18/2015 13:07'!
glmAnimateValue: aValue duration: anInteger callback: aBlock
	
	self animation ifNotNil: #terminate.
	animation := GLMAnimation new
		linear;
		duration: 300;
		from: self scrollValue;
		to: (self convertScrollValue: aValue);
		ensure: [ :b | b updatePaneBounds. aBlock brickValue: b ];
		animation: [ :b :v | b scrollValue: v ];
		animate: self! !

!GLMPagerScrollBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/8/2015 16:58'!
initialize
	super initialize.
	
	focus := Dictionary new.
	currentScrollDelta := 0.
	maxPanes := 2.
	self band: self newBand.
	Morph announcer weak 
		when: MorphGotFocus send: #focusChanged: to: self.! !

!GLMPagerScrollBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/4/2014 12:38'!
lastPane

	self subbricksCount = 0 ifTrue: [ ^ nil ].
	^ self panes last.! !

!GLMPagerScrollBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/4/2014 12:09'!
maxPanes
	^ maxPanes! !

!GLMPagerScrollBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/4/2014 12:09'!
maxPanes: anInteger
	maxPanes := anInteger! !

!GLMPagerScrollBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 2/14/2015 13:31'!
newBand

	^ GLMScrollPaneBandBrick new! !

!GLMPagerScrollBrick methodsFor: 'brick-layout-events' stamp: 'AliakseiSyrel 2/29/2016 14:07'!
onChildrenLayouted
	super onChildrenLayouted.
	self band translateXTo: (self convertScrollValue: (self pagerModel convertIndexToValue: self pagerModel firstVisiblePageIndex))! !

!GLMPagerScrollBrick methodsFor: 'event-handling' stamp: 'AliakseiSyrel 12/4/2014 12:36'!
onPagePoped: popedAnnouncement
	self popPane: popedAnnouncement smooth.! !

!GLMPagerScrollBrick methodsFor: 'event-handling' stamp: 'AliakseiSyrel 2/17/2015 15:08'!
onPagePopedAndReplaced: ann

	self popAndReplace: ann brick! !

!GLMPagerScrollBrick methodsFor: 'event-handling' stamp: 'AliakseiSyrel 12/4/2014 09:46'!
onPagePreviewUpdate: updateAnnouncement

	GLMPagerPanePreviewMorph uniqueInstance updateFor: (self paneAt: updateAnnouncement pageIndex).! !

!GLMPagerScrollBrick methodsFor: 'event-handling' stamp: 'AliakseiSyrel 2/16/2015 12:18'!
onPagePushed: pushedAnnouncement

	"added new page to the end of pane"
	self pushPane: pushedAnnouncement morph
	
	
	
	
! !

!GLMPagerScrollBrick methodsFor: 'event-handling' stamp: 'AliakseiSyrel 2/17/2015 17:45'!
onPagesNumberChanged

	self maxPanes: pagerModel numberOfVisiblePages.
	self doLayoutForce.
	self scrollToPane: pagerModel firstVisiblePageIndex smooth: false
	! !

!GLMPagerScrollBrick methodsFor: 'event-handling' stamp: 'AliakseiSyrel 2/14/2015 12:25'!
onPositionChanged: announcement


	self scrollToPane: pagerModel firstVisiblePageIndex smooth: announcement smooth callback: announcement callback! !

!GLMPagerScrollBrick methodsFor: 'event-handling' stamp: 'AliakseiSyrel 12/4/2014 09:47'!
onSelectedPageChanged
	
	self panes do: [ :each | each borderColor: Color transparent ].
	
	self theme pagerWidgetThemer selectedPaneStyleFor: (self panes at: pagerModel selectedPageIndex)! !

!GLMPagerScrollBrick methodsFor: 'event-handling' stamp: 'AliakseiSyrel 12/4/2014 09:47'!
onSynchronizeScroll: announcement

	"directly scrolls to value"
	self scrollTo: announcement value smooth: false! !

!GLMPagerScrollBrick methodsFor: 'initialize' stamp: 'AliakseiSyrel 12/4/2014 09:47'!
outOfWorld: aWorld

	Morph announcer unsubscribe: self.
	^ super outOfWorld: aWorld.! !

!GLMPagerScrollBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/4/2014 09:48'!
pageOf: aSubMorph
	"returns 0 if morph is not in pager"
	|parent page|	
	
	aSubMorph ifNil: [ ^ 0 ].
	
	parent := aSubMorph.
	
	[parent isNotNil & ((parent == self band) not) ] whileTrue: [
		page := parent.
		parent := parent owner.
	].
	
	^ parent isNil ifTrue: [ 0 ] ifFalse: [ self panes indexOf: page. ].
	! !

!GLMPagerScrollBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/4/2014 13:36'!
pagerModel

	^ pagerModel! !

!GLMPagerScrollBrick methodsFor: 'accessing' stamp: 'PavelKrivanek 4/6/2016 16:16'!
pagerModel: aModel
	
	pagerModel := aModel.
	maxPanes := aModel numberOfVisiblePages.
	
	pagerModel announcer 
		when: GLMPagePushed send: #onPagePushed: to: self.
	
	pagerModel announcer 
		when: GLMPagePoped send: #onPagePoped: to: self.
	
	pagerModel announcer 
		when: GLMPagePopedAndReplaced send: #onPagePopedAndReplaced: to: self.
						
	pagerModel announcer 
		when: GLMPagerSynchronizeScrollAnnouncement send: #onSynchronizeScroll: to: self.
		
	pagerModel announcer  
		when: GLMPagerScrollPositionChanged send: #onPositionChanged: to: self.
		
	pagerModel announcer  
		when: GLMNumberOfVisiblePagesChanged send: #onPagesNumberChanged to: self.
		
	pagerModel announcer  
		when: GLMSelectedPageChanged send: #onSelectedPageChanged to: self.
		
	pagerModel announcer  
		when: GLMPagerPreviewUpdate send: #onPagePreviewUpdate: to: self.! !

!GLMPagerScrollBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/4/2014 11:53'!
paneAt: anIndex
	^ self panes at: anIndex.! !

!GLMPagerScrollBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/9/2015 14:50'!
paneMargin
	"please leave it 0, becasue otherwise it doesn't work"
	self flag: 'fix support of margin'.
	^ 0! !

!GLMPagerScrollBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/4/2014 11:57'!
panes

	^ self band submorphs! !

!GLMPagerScrollBrick methodsFor: 'api' stamp: 'AliakseiSyrel 2/17/2015 17:33'!
popAndReplace: aBrick
	|brick|

	brick := self configurePane: aBrick.
	brick wrappedBounds: self band lastSubbrick wrappedBounds.
	brick updateMorphBounds.
	
	self band doNotLayoutDuring: [ :b | b
		removeBrick: b lastSubbrick;
		addBrickBack: brick ].
	self changed
	
	! !

!GLMPagerScrollBrick methodsFor: 'api' stamp: 'AliakseiSyrel 2/16/2015 12:47'!
popPane
	
	self band doNotLayoutDuring: [ :b | b removeBrick: b lastSubbrick ].
	self doLayoutForce! !

!GLMPagerScrollBrick methodsFor: 'api' stamp: 'AliakseiSyrel 2/18/2015 13:17'!
popPane: isSmooth

	(isSmooth not or: [self lastPane isNil]) ifTrue: [ ^ self popPane ].
	
	self band doNotLayoutDuring: [ :b | b removeBrick: b lastSubbrick ].
	self
		scrollTo: (pagerModel convertIndexToValue: pagerModel firstVisiblePageIndex with: self band subbricksCount)
		smooth: isSmooth
		callback: [ self doLayoutForce ]! !

!GLMPagerScrollBrick methodsFor: 'api' stamp: 'AliakseiSyrel 2/17/2015 17:28'!
pushPane: aMorph

	self band addBrickBack: (self configurePane: aMorph)! !

!GLMPagerScrollBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 2/14/2015 12:32'!
scrollTo: aValue smooth: isSmooth

 	self scrollTo: aValue smooth: isSmooth callback: nil! !

!GLMPagerScrollBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 2/29/2016 14:07'!
scrollTo: aValue smooth: isSmooth callback: aBlock

 	isSmooth ifTrue: [ self glmAnimateValue: aValue duration: 300 callback: aBlock ]
				ifFalse: [ self scrollValue: (self convertScrollValue: aValue). self updatePaneBounds. aBlock value ].! !

!GLMPagerScrollBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 12/4/2014 09:49'!
scrollToPane: anIndex smooth: isSmooth

	self scrollToPane: anIndex smooth: isSmooth callback: nil! !

!GLMPagerScrollBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 12/4/2014 09:49'!
scrollToPane: anIndex smooth: isSmooth callback: aBlock

	self scrollTo: (pagerModel convertIndexToValue: anIndex) smooth: isSmooth callback: aBlock.! !

!GLMPagerScrollBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/4/2014 13:57'!
scrollValue

	^ currentScrollDelta! !

!GLMPagerScrollBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 2/17/2015 13:41'!
scrollValue: value
	
	currentScrollDelta := value.
	
	self band doNotLayoutDuring: [ :b | b translateXTo: self scrollValue ].
	self changed! !

!GLMPagerScrollBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 2/16/2015 12:12'!
updatePaneBounds

	self band updateMorphBounds! !

Object subclass: #GLMPagerModel
	instanceVariableNames: 'numberOfVisiblePages announcer firstVisiblePageIndex pagesCount lastVisiblePageIndex selectedPageIndex focusedMorphs focusedPageIndex virtualFirstVisiblePageIndex virtualLastVisiblePageIndex scrollButtonIconRenderBlock isDependenciesShown scrollToRightTask isNotificationsAllowed scrollingDelay minimumPageNumberForScrollbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Model'!

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/26/2014 20:29'!
actualNumberOfVisiblePages
	"returns actual number of visible pages based on first and last visible page indexes"

	(firstVisiblePageIndex = lastVisiblePageIndex) & (firstVisiblePageIndex = 0) ifTrue: [ ^ 0 ].
	^ lastVisiblePageIndex - firstVisiblePageIndex + 1.! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/3/2014 20:30'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GLMPagerModel methodsFor: 'focus' stamp: 'AliakseiSyrel 5/27/2014 23:40'!
assignFocusableMorph: aMorph withPaneAt: paneIndex
	"assigns previosely focused morph with corresponding pane"
	
	focusedMorphs at: paneIndex put: aMorph.! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 8/18/2014 20:08'!
circleButtonSize
	^ 22! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AliakseiSyrel 10/14/2014 09:56'!
convertIndexToValue: anIndex
	
	^ self convertIndexToValue: anIndex with: self size! !

!GLMPagerModel methodsFor: 'private' stamp: 'AliakseiSyrel 10/14/2014 09:56'!
convertIndexToValue: anIndex with: numberOfPagers
	"private"
	numberOfPagers = self actualNumberOfVisiblePages
		ifTrue: [ ^ 0 ]
		ifFalse: [ ^ (anIndex - 1) / (numberOfPagers - self actualNumberOfVisiblePages ) ]! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/27/2014 13:27'!
convertValueToIndex: aValue
	
	^ (self size - self actualNumberOfVisiblePages) * aValue + 1.! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AndreiChis 4/15/2014 12:18'!
defaultNumberOfVisiblePages
	^ 2! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/27/2014 11:06'!
defaultNumberOfVisiblePages: anInteger
	"use it only when the number of pages is 0"
	self size = 0 ifFalse: [ GLMPagerException signal: 'You can change default number of visible pages only when there is no pages' ].
	numberOfVisiblePages := anInteger.! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 6/29/2014 00:28'!
dependencyButtonSize
	^ self isDependenciesShown ifTrue: [ self circleButtonSize ] ifFalse: [ 0 ].! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/27/2014 15:10'!
diminishToLeft

	self actualNumberOfVisiblePages = 1 ifTrue: [ ^ self ].
	self virtualLastVisiblePageIndex: (self lastVisiblePageIndex - 1).
	self recomputeState.! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/27/2014 15:10'!
diminishToRight

	self actualNumberOfVisiblePages = 1 ifTrue: [ ^ self ].
	self virtualFirstVisiblePageIndex: (self firstVisiblePageIndex + 1).
	self recomputeState.! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/17/2015 17:44'!
doNotNotifyDuring: aBlock
	|allowed|
	allowed := self isNotificationsAllowed.
	isNotificationsAllowed := false.
	aBlock cull: self.
	allowed ifTrue: [ isNotificationsAllowed := true ]! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/27/2014 15:01'!
enlargeToLeft

	self virtualFirstVisiblePageIndex: (self firstVisiblePageIndex - 1).
	self recomputeState.! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/27/2014 15:01'!
enlargeToRight

	self virtualLastVisiblePageIndex: (self lastVisiblePageIndex + 1).
	self recomputeState.! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/5/2014 22:23'!
firstVisiblePageIndex
	^ firstVisiblePageIndex! !

!GLMPagerModel methodsFor: 'focus' stamp: 'AliakseiSyrel 5/27/2014 23:37'!
focusPaneAt: pageIndex
	"tries to focus previosely focused morph at specified pane by its index"
	
	( self isFocusedMorphVisibleAt: pageIndex ) ifTrue: [
		focusedPageIndex := pageIndex.
		(self focusedMorphAt: pageIndex) activeHand newKeyboardFocus: (self focusedMorphAt: pageIndex).
		self notifyFocusedPageChanged.
	].! !

!GLMPagerModel methodsFor: 'focus' stamp: 'AliakseiSyrel 5/27/2014 23:41'!
focusedMorphAt: pageIndex
	"returns previosely focused morph in the pane or nil if no morph was focused"
	
	^ focusedMorphs at: pageIndex ifAbsent: [ nil ]! !

!GLMPagerModel methodsFor: 'focus' stamp: 'AliakseiSyrel 2/29/2016 14:08'!
focusedMorphChanged: aMorph at: pageIndex
	"call this method if a morph was focused in a pane with specified index. As a result corresponding pane will be marked as selected"
	
	
	self assignFocusableMorph: aMorph withPaneAt: pageIndex.
	
	focusedPageIndex = pageIndex ifFalse: [ 
		focusedPageIndex := pageIndex.
		self notifyFocusedPageChanged ]
	! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/23/2014 19:26'!
focusedPageIndex
	^ focusedPageIndex! !

!GLMPagerModel methodsFor: 'initialization' stamp: 'AliakseiSyrel 6/29/2014 00:29'!
initialize
	super initialize.

	pagesCount := 0.
	selectedPageIndex := 0.
	focusedMorphs := Dictionary new.
	isDependenciesShown := false.
		
	numberOfVisiblePages := self defaultNumberOfVisiblePages.
	
	firstVisiblePageIndex:= 0.
	lastVisiblePageIndex:= 0.
	
	self invariant.! !

!GLMPagerModel methodsFor: 'invariant' stamp: 'AliakseiSyrel 5/28/2014 01:09'!
invariant
	"If any of these exceptions rise, please notify us through moose-dev mail list. Your help is appreciated"
	
	self isDebug ifFalse: [ ^ self ].
	
	pagesCount >= 0 ifFalse: [ GLMPagerException signal: 'The number of page must be non negative' ].

	pagesCount > 1 ifTrue: [
		firstVisiblePageIndex >= 1 ifFalse: [GLMPagerException signal: 'First visible page index must be > 1 if number of pages > 0'].
		lastVisiblePageIndex >= 1 ifFalse: [GLMPagerException signal: 'Last visible page index must be > 1 if number of pages > 0'].
		lastVisiblePageIndex <= pagesCount ifFalse: [ GLMPagerException signal: 'Last visible page index must be less or equals to the number of pages' ].
		self actualNumberOfVisiblePages <= numberOfVisiblePages ifFalse: [ GLMPagerException signal: 'Actual number of visible pages must be less or equals to current number of visible pages' ].
		selectedPageIndex >= 1 ifFalse: [ GLMPagerException signal: 'Selected page index must be greater or equals then 1 if number of pages is more than 1' ].
	].

	pagesCount = 1 ifTrue: [ 
		firstVisiblePageIndex = 1 ifFalse: [GLMPagerException signal: 'First visible page index must be 1 if number of pages is 1'].
		lastVisiblePageIndex = 1 ifFalse: [GLMPagerException signal: 'Last visible page index must be 1 if number of pages is 1'].
		lastVisiblePageIndex = firstVisiblePageIndex ifFalse: [ GLMPagerException signal: 'First and Last visible page indexes must be equal if number of pages is 1' ].
		self actualNumberOfVisiblePages = 1 ifFalse: [ GLMPagerException signal: 'Actual number of visible pages must be 1 if number of pages is 1' ].
		selectedPageIndex = 1 ifFalse: [ GLMPagerException signal: 'Selected page index must be 1 if number of pages is 1' ].
	].

	pagesCount = 0 ifTrue: [ 
		firstVisiblePageIndex = 0 ifFalse: [GLMPagerException signal: 'First visible page index must be 0 if number of pages is 0'].
		lastVisiblePageIndex = 0 ifFalse: [GLMPagerException signal: 'Last visible page index must be 0 if number of pages is 0'].
		self actualNumberOfVisiblePages = 0 ifFalse: [ GLMPagerException signal: 'Actual number of visible pages must be 0 if there is no pages' ].
		selectedPageIndex = 0 ifFalse: [ GLMPagerException signal: 'Selected page index must be 0 if number of pages is 0' ].
	]! !

!GLMPagerModel methodsFor: 'initialization' stamp: 'AliakseiSyrel 2/9/2015 14:47'!
isDebug

	^ true! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 6/29/2014 00:28'!
isDependenciesShown
	^ isDependenciesShown! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 6/29/2014 00:29'!
isDependenciesShown: aBoolean
	isDependenciesShown := aBoolean! !

!GLMPagerModel methodsFor: 'focus' stamp: 'AliakseiSyrel 4/23/2014 20:34'!
isFocusedMorphVisibleAt: paneIndex
	|morph|
	
	morph := self focusedMorphAt: paneIndex.
	morph ifNil: [ ^ false ].
	^ morph isInWorld.! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/17/2015 14:59'!
isNotificationsAllowed

	^ isNotificationsAllowed ifNil: [ isNotificationsAllowed := true ]! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/28/2014 00:38'!
isPaneVisible: aNumber

	^ (aNumber >= self firstVisiblePageIndex) & (aNumber <= self lastVisiblePageIndex)! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/5/2014 22:24'!
lastVisiblePageIndex
	| lastIndex |
	
	lastIndex := self firstVisiblePageIndex + self numberOfVisiblePages - 1.
	^ lastIndex > self size
		ifTrue: [ self size ]
		ifFalse: [ lastIndex ]! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AndreiChis 1/10/2016 12:32'!
minimumPageNumberForScrollbar
	^ minimumPageNumberForScrollbar ifNil: [ 1 ]! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AndreiChis 1/10/2016 12:31'!
minimumPageNumberForScrollbar: aNumber
	minimumPageNumberForScrollbar := aNumber! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/28/2014 00:37'!
normalizePaneIndex: anIndex
	"retunes normalized pane index. For example: returns 1 if index < 1 and size if index > self size"
	
	anIndex < 1 ifTrue: [ ^ 1 ].
	anIndex > self size ifTrue: [ ^ self size ].
	^ anIndex.! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/17/2015 15:01'!
notifyAll: anAnnouncement
	
	self isNotificationsAllowed ifTrue: [
		self announcer announce: anAnnouncement ]! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/17/2015 15:01'!
notifyFocusedPageChanged

	self notifyAll: GLMFocusedPageChanged new.! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/17/2015 15:01'!
notifyNumberOfVisiblePagesChanged

	self notifyAll: GLMNumberOfVisiblePagesChanged new.! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/17/2015 15:01'!
notifyPagePoped: isSmooth

	self notifyAll: (GLMPagePoped new smooth: isSmooth).! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/17/2015 15:07'!
notifyPagePoppedAndReplaced: aBrick

	self notifyAll: (GLMPagePopedAndReplaced new brick: aBrick)! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/17/2015 19:18'!
notifyPagePushed: aMorph scrollTo: isScroll smooth: isSmooth
	
	self notifyAll: (GLMPagePushed new morph: aMorph).
	
	isScroll ifTrue: [
		self scrollingDelay > 0
			ifTrue: [ self scrollToRightTask execute: { isSmooth } ]
			ifFalse: [ self scrollToRight: isSmooth ] ]! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'AliakseiSyrel 11/15/2014 16:13'!
notifyScrollPositionChanged: isSmooth

	self notifyScrollPositionChanged: isSmooth callback: nil! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/17/2015 15:01'!
notifyScrollPositionChanged: isSmooth callback: aBlock

	self notifyAll: (GLMPagerScrollPositionChanged new smooth: isSmooth; callback: aBlock; yourself).! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/17/2015 15:01'!
notifyScrollerBoundsChanged: aBounds

	self notifyAll: (GLMPagerBoundsChanged new bounds: aBounds).! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/17/2015 15:01'!
notifySelectedPageChanged

	self notifyAll:  GLMSelectedPageChanged new.! !

!GLMPagerModel methodsFor: 'notifying' stamp: 'AliakseiSyrel 2/17/2015 15:01'!
notifySynchronizeScrollTo: aValue 
	
	self notifyAll: (GLMPagerSynchronizeScrollAnnouncement new value: aValue).! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/4/2014 10:37'!
numberOfVisiblePages
	^ numberOfVisiblePages! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 2/17/2015 15:07'!
popAndReplacePane: aMorph
	
	self doNotNotifyDuring: [ :m |
		m popPane;
			pushPane: aMorph smooth: false ].
		
	self notifyPagePoppedAndReplaced: aMorph! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 10/14/2014 09:16'!
popPane

	self popPane: false.! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 11/15/2014 15:17'!
popPane: isSmooth

	self invariant.
	
	pagesCount >= 1 ifTrue: [
		|scrollTo smooth|
		smooth := isSmooth.
		
		focusedMorphs removeKey: pagesCount  ifAbsent: [ true ].
		pagesCount := pagesCount - 1.
		
		firstVisiblePageIndex = 1 ifTrue: [ smooth := false ].
		
		lastVisiblePageIndex > pagesCount ifTrue: [
			firstVisiblePageIndex := firstVisiblePageIndex - 1.
			lastVisiblePageIndex := lastVisiblePageIndex - 1.
		].
	
		firstVisiblePageIndex := firstVisiblePageIndex max: 1.
	
		pagesCount = 0 ifTrue: [
			selectedPageIndex := 0.
			firstVisiblePageIndex := 0.
		].
		
		self selectedPageIndex > pagesCount ifTrue: [
			self selectedPageIndex: pagesCount.
		].
	
		scrollTo := ((pagesCount = firstVisiblePageIndex) & (pagesCount > self numberOfVisiblePages)).
		self notifyPagePoped: smooth.
	].

	self invariant.! !

!GLMPagerModel methodsFor: 'private' stamp: 'AliakseiSyrel 5/27/2014 14:15'!
privateRecomputeIndexesAfterScrollAt: aFloat
	"while rounding fractional part < 0.5"
	|left right|
	
	self invariant.
	
	left := self convertValueToIndex: aFloat.
	right := left + self actualNumberOfVisiblePages - 1.
	firstVisiblePageIndex := left rounded.
	lastVisiblePageIndex := right rounded.
	
	lastVisiblePageIndex > self size ifTrue: [
		|delta|
		delta := lastVisiblePageIndex - self size.
		firstVisiblePageIndex := firstVisiblePageIndex - delta.
		lastVisiblePageIndex := lastVisiblePageIndex - delta.
	].
		
	self invariant.
	
	! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/28/2014 00:22'!
pushPane: aMorph smooth: aBoolean

	self invariant.
	
	pagesCount := pagesCount + 1.
	
	self size = 1
		ifTrue: [ 
			firstVisiblePageIndex := 1.
			lastVisiblePageIndex := 1.
			selectedPageIndex := 1.
		]
		ifFalse: [ 
			(self actualNumberOfVisiblePages < self numberOfVisiblePages) ifTrue: [
				lastVisiblePageIndex := lastVisiblePageIndex + 1.
			].
		].
	
	self notifyPagePushed: aMorph scrollTo: true smooth: aBoolean.
	self size = 1 ifTrue: [ self notifySelectedPageChanged ].
	
	self invariant.! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 8/18/2014 21:19'!
recomputeState
	self recomputeState: true
	! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 8/18/2014 21:19'!
recomputeState: isSmooth
	"recomputes current model state and if necessary notifies all listeners about changes"
	|tmpNumberOfVisiblePages notifyNumberOfVisiblePagesChanged|
	
	notifyNumberOfVisiblePagesChanged := false.
	
	self invariant.
	
	((virtualFirstVisiblePageIndex isNil) & (virtualLastVisiblePageIndex isNil)) ifTrue: [ ^ self ].
	virtualFirstVisiblePageIndex ifNil: [ virtualFirstVisiblePageIndex := self firstVisiblePageIndex ].
	virtualLastVisiblePageIndex ifNil: [ virtualLastVisiblePageIndex := self lastVisiblePageIndex ].
	
	tmpNumberOfVisiblePages := virtualLastVisiblePageIndex - virtualFirstVisiblePageIndex + 1.
	tmpNumberOfVisiblePages = numberOfVisiblePages ifFalse: [ notifyNumberOfVisiblePagesChanged := true ].
	numberOfVisiblePages := tmpNumberOfVisiblePages.
	
	firstVisiblePageIndex := virtualFirstVisiblePageIndex.
	lastVisiblePageIndex := virtualLastVisiblePageIndex.

	self invariant.
	
	virtualFirstVisiblePageIndex = nil.
	virtualLastVisiblePageIndex = nil.
	
	notifyNumberOfVisiblePagesChanged ifTrue: [ self notifyNumberOfVisiblePagesChanged ].
	self notifyScrollPositionChanged: isSmooth.
	! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 6/28/2014 22:05'!
scrollButtonIconRenderBlock
	^ scrollButtonIconRenderBlock! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 6/28/2014 22:05'!
scrollButtonIconRenderBlock: anObject
	scrollButtonIconRenderBlock := anObject! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AliakseiSyrel 11/15/2014 16:11'!
scrollTo: aFloat smooth: isSmooth
	
	self scrollTo: aFloat smooth: isSmooth callback: nil! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AliakseiSyrel 11/15/2014 16:12'!
scrollTo: aFloat smooth: isSmooth callback: aBlock
	"notifies all listeners to scroll at the specified value"
	
	self privateRecomputeIndexesAfterScrollAt: aFloat.
	self notifyScrollPositionChanged: isSmooth callback: aBlock! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AliakseiSyrel 11/15/2014 16:11'!
scrollToPane: pageIndex
	
	self scrollToPane: pageIndex callback: nil
	! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AliakseiSyrel 11/15/2014 16:12'!
scrollToPane: pageIndex callback: aBlock
	"scrolls to specified pane specified by its index"

	self scrollTo: (self convertIndexToValue: pageIndex) smooth: true callback: aBlock
	! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/26/2014 20:18'!
scrollToRight: isSmooth
	"notifies all listeners that it is time to scroll most right"

	self scrollTo: 1.0 smooth: isSmooth! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AliakseiSyrel 2/17/2015 19:17'!
scrollToRightTask

	^ scrollToRightTask ifNil: [
		scrollToRightTask := GLMAsyncTask new.
		scrollToRightTask
			doInBackground: [ :isSmooth | isSmooth ];
			onCompleted: [ :isSmooth | self scrollToRight: isSmooth ];
			delay: self scrollingDelay ]! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AliakseiSyrel 2/17/2015 19:19'!
scrollingDelay

	^ scrollingDelay ifNil: [ scrollingDelay := 100 ]! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 2/17/2015 19:19'!
scrollingDelay: anInteger

	scrollingDelay := anInteger! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/28/2014 00:38'!
selectToLeft
	"moves focus to left"
	
	self selectedPageIndex: (self selectedPageIndex - 1).! !

!GLMPagerModel methodsFor: 'panes' stamp: 'AliakseiSyrel 5/28/2014 00:34'!
selectToRight
	"moves focus to right"
	
	self selectedPageIndex: (self selectedPageIndex + 1).! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 4/23/2014 19:16'!
selectedPageIndex
	^ selectedPageIndex! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/5/2014 22:23'!
selectedPageIndex: anIndex
	| normalizedIndex |
	"changes current selected page and scrolls to it if necessary. Also if possible re-focused available morph"
	
	normalizedIndex := self normalizePaneIndex: anIndex.
	
	(self isPaneVisible: normalizedIndex) ifFalse: [
		"we need to scroll if new selected page is invisible"
		self scrollToPane: (normalizedIndex < self firstVisiblePageIndex ifTrue: [ normalizedIndex ] ifFalse: [(normalizedIndex - self numberOfVisiblePages + 1)]).
	].
	
	selectedPageIndex := normalizedIndex.
	self focusPaneAt: normalizedIndex.
	self notifySelectedPageChanged.

	self invariant.! !

!GLMPagerModel methodsFor: 'accessing' stamp: 'AliakseiSyrel 5/26/2014 19:29'!
size
	^ pagesCount.! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AndreiChis 8/29/2014 12:52'!
switchPaneTo: anIndex
	| normalizedIndex |
	"switches pane to specified. Works as scrollToPane, but additionaly selects and focuses that pane."
	
	self invariant.
	
	normalizedIndex := self normalizePaneIndex: anIndex.
	
	self scrollToPane: normalizedIndex.	
	self focusPaneAt: normalizedIndex.
	
	selectedPageIndex := normalizedIndex.
	self notifySelectedPageChanged.
	
	self invariant.! !

!GLMPagerModel methodsFor: 'scrolling' stamp: 'AliakseiSyrel 5/27/2014 14:29'!
synchronizeScrollTo: aValue
	
	self notifySynchronizeScrollTo: aValue.! !

!GLMPagerModel methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/26/2014 13:50'!
updatePreview: anIndex

	self announcer announce: (GLMPagerPreviewUpdate new pageIndex: anIndex )! !

!GLMPagerModel methodsFor: 'private' stamp: 'AliakseiSyrel 5/26/2014 17:58'!
virtualFirstVisiblePageIndex
	^ virtualFirstVisiblePageIndex! !

!GLMPagerModel methodsFor: 'private' stamp: 'AndreiChis 6/28/2014 21:11'!
virtualFirstVisiblePageIndex: anIndex

	virtualFirstVisiblePageIndex := self normalizePaneIndex: anIndex.
	! !

!GLMPagerModel methodsFor: 'private' stamp: 'AliakseiSyrel 5/28/2014 00:57'!
virtualLastVisiblePageIndex

	^ virtualLastVisiblePageIndex! !

!GLMPagerModel methodsFor: 'private' stamp: 'AndreiChis 6/28/2014 21:11'!
virtualLastVisiblePageIndex: anIndex.

	virtualLastVisiblePageIndex := self normalizePaneIndex: anIndex.! !

Object subclass: #GLMPagerWidgetThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Pager-Theme'!

!GLMPagerWidgetThemer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 2/9/2015 14:29'!
defaultScrollButtonStyleFor: aButton

	aButton checkedIcon: GLMUIThemeExtraIcons glamorousGrayCircleEmpty.
	aButton checkedFocusedIcon: GLMUIThemeExtraIcons glamorousGrayCircle.
	
	aButton normalImage: GLMUIThemeExtraIcons glamorousGrayCircleEmpty.
	aButton selectedImage: GLMUIThemeExtraIcons glamorousGrayCircle.
	aButton checkedImage: aButton checkedIcon.! !

!GLMPagerWidgetThemer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/26/2014 14:43'!
previewPaneStyleFor: aMorph

	aMorph borderColor: (Color lightGray)! !

!GLMPagerWidgetThemer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 5/28/2014 00:43'!
selectedPaneStyleFor: aMorph

	aMorph borderColor: (Color transparent)! !
